'use strict';

var IOFABRIC_VERSION = '0.50';
$(document).ready(function () {
  $("#accordion").accordion();
  $('#proxy-info').accordion();

  var accTok = apwGetAccessToken();

  getFogTypesList(accTok).then(function (result) {
    AppWorks_Start();

    $('.modal-trigger').leanModal();
    $('.tooltipped').tooltip({ delay: 50 });
    $('#proxy-close-button').hide();

    loadInstances().then(function (res) {
      setupChangeMonitors();
      activateHandlersForFabricInterface();

      $('#fabric-instance-provision-button').click(function () {
        if (selectedInstance != '') {
          getProvisioningKey(selectedInstance);
        } else {
          Materialize.toast('No Fog instance is selected.', 5000);
        }
      });

      $('#delete-confirm-modal-yes-button').click(function () {
        if (selectedInstance != '') {
          $('#deleteconfirmmodal').closeModal();
          var id = $('.fabric-instance-selected').attr('data-fabric-instance-id');
          deleteFabricInstance(id);
        } else {
          Materialize.toast('No Fog instance is selected.', 5000);
        }
      });

      $('#proxy-modal-open-button').click(function () {
        if (selectedInstance != '') {
          $('#opensshtunnelmodal').closeModal();
          var id = $('.fabric-instance-selected').attr('data-fabric-instance-id');
          openSshTunnel(id);
        } else {
          Materialize.toast('No Fog instance is selected.', 5000);
        }
      });

      $('#proxy-close-button').click(function () {
        if (selectedInstance != '') {
          var id = $('.fabric-instance-selected').attr('data-fabric-instance-id');
          closeSshTunnel(id);
        } else {
          Materialize.toast('No Fog instance is selected.', 5000);
        }
      });

      $('#reboot-confirm-modal-yes-button').click(function () {
        if (selectedInstance != '') {
          $('#rebootmodal').closeModal();
          $(".fabric-instance-container.fabric-instance-selected").attr('fabric-instance-reboot', true);
          updateInstanceSetting();
        } else {
          Materialize.toast('No Fog instance is selected.', 5000);
        }
      });

      $('#fabric-instance-delete-button').click(function () {
        //showDeleteConfirmModal();
      });

      $('#version-upgrade-modal-yes-button').click(function () {
        if (selectedInstance != '') {
          $('#versionupgrademodal').closeModal();
          var id = $('.fabric-instance-selected').attr('data-fabric-instance-id');
          changeIoFogVersion(id, 'upgrade');
        } else {
          Materialize.toast('No Fog instance is selected.', 5000);
        }
      });

      $('#version-rollback-modal-yes-button').click(function () {
        if (selectedInstance != '') {
          $('#versionupgrademodal').closeModal();
          var id = $('.fabric-instance-selected').attr('data-fabric-instance-id');
          changeIoFogVersion(id, 'rollback');
        } else {
          Materialize.toast('No Fog instance is selected.', 5000);
        }
      });
    });
  });
});

var getFogTypesList = function getFogTypesList(accTok) {
  return $.ajax({
    url: fogControllerUrl + ioAuthoring.urls.getFogTypesList + '?t=' + accTok,
    dataType: "json",
    success: function success(res) {
      if (res.status == 'ok') {
        $("#fogTypeContainer").html(ejs.render(ioAuthoring.templates.fogTypeList, { "fogTypes": res.fogTypes }, {}));
      }
    }
  });
};